LeetCode——456. 132 模式

LeetCode------456. 132 模式

问题描述

给定一个整数数组 nums,数组中共有 n 个整数。132 模式的子序列由三个整数 nums[i]、nums[j] 和 nums[k] 组成,并同时满足:

  • i < j < k
  • nums[i] < nums[k] < nums[j]

如果 nums 中存在 132 模式的子序列,返回 true;否则,返回 false。

示例

示例 1

输入 : nums = [1,2,3,4]
输出 : false
解释: 序列中不存在 132 模式的子序列。

示例 2

输入 : nums = [3,1,4,2]
输出 : true
解释 : 序列中有 1 个 132 模式的子序列:[1, 4, 2]。

示例 3

输入 : nums = [-1,3,2,0]
输出 : true
解释 : 序列中有 3 个 132 模式的子序列:[-1, 3, 2]、[-1, 3, 0] 和 [-1, 2, 0]。

提示

  • n == nums.length
  • 1 <= n <= 2 * 10^5
  • -10^9 <= nums[i] <= 10^9

解决方法

  这道题有两个方向,一是暴力求解,二是单调栈。

在leetcode上建议使用单调栈,暴力求解有个别用例会过不去。

代码实现

暴力算法 O(n3)

c 复制代码
//暴力解法O(n^3)
bool find132pattern(int* nums, int numsSize) {
    if (numsSize < 3) {	//长度小于 3 无法构成
        return false;
    }
    for (int i = 0; i <= numsSize - 3; i++) {
        for (int j = i + 1; j <= numsSize - 2; j++) {
            for (int k = j + 1; k <= numsSize - 1; k++) {
                if (nums[i] < nums[k] && nums[k] < nums[j]) {
                    return true;
                }
            }
        }
    }
    return false;
}

暴力算法 O(n2)

c 复制代码
//暴力优化O(n^2)
bool find132pattern(int* nums, int numsSize) {
    if (numsSize < 3) {	//长度小于 3 无法构成
        return false;
    }

    for (int j = 1; j < numsSize - 1; j++) {
        int min = nums[0];
        for (int i = 1; i < j; i++) {
            if (nums[i] < min) {
                min = nums[i];		//j作为中间下标,找j左边最小,更容易满足条件
            }
        }
        for (int k = j + 1; k < numsSize; k++) {
            if (min < nums[k] && nums[k] < nums[j]) {
                return true;
            }
        }
    }
    return false;
}

单调栈O(n)

c 复制代码
bool find132pattern(int* nums, int numsSize) {
    if (numsSize < 3) {
        return false;
    }

    int max_k = INT_MIN;	//存放k的最大值(初始化为最小值)
    int* stack = (int*)malloc(numsSize * sizeof(int));
    int top = -1;	//栈顶下标

    for (int i = numsSize; i >= 0; i--) {
        if (nums[i] < max_k) {
            free(stack);
            return true;
        }
        while (top >= 0 && nums[i] > stack[top]) {
            max_k = stack[top--];
        }
        stack[++top] = nums[i];
    }

    free(stack);
    return false;
}

  单调栈可能有点不好理解,下面将给出图例说明。

提示:

  • numsi = 1(模式中的"1")

  • max_k = 2(模式中的"2")

  • stack = {4}(模式中的"3")

相关推荐
ZhengEnCi9 小时前
Agent 架构怎么选:从单 Agent 到多 Agent 编排的选型决策指南
算法·架构
秋天的怀念_David9 小时前
第二十二夜 · 数字迷雾
java·程序人生·算法
Pniubi9 小时前
力扣283移动零(双指针法)
算法·leetcode·职场和发展
hhb_61810 小时前
大模型落地三重优化实战
人工智能·算法·机器学习
云和数据.ChenGuang10 小时前
光哥说Python RAG 系统需要哪些评估指标:从检索到生成的全链路评测指南
网络·人工智能·python·算法·langchain
2601_9707038311 小时前
工业除湿机租赁:把一份租金合同拆开看
大数据·数据结构·算法·数据库架构·推荐算法
心中有你021411 小时前
Java实现Dijkstra最短路径算法(邻接表 + 优先队列)
java·数据库·算法
ZhengEnCi12 小时前
同样的模型,为什么本地和云 API 差别那么大:量化精度、聊天模板与采样参数的三大元凶
人工智能·算法·llm
Flynn Liang13 小时前
RAG 答非所问/幻觉怎么破?Spring AI QuestionAnswerAdvisor 召回优化实战(TopK/重排/混合检索)
人工智能·算法·spring·rag·幻觉·springai
liminla!13 小时前
SQL 从入门到进阶:语法速查与实战练习(完整优化版)
数据库·sql·算法